<script>
import { ref, computed, onMounted, reactive } from "vue";
import store from "@/store"
import useValidate from "@vuelidate/core";
import { required, email, minLength, sameAs, helpers } from "@vuelidate/validators";
import { HTTP } from "@/components/common/HttpCommon";
import SimpleTypeahead from 'vue3-simple-typeahead'
import 'vue3-simple-typeahead/dist/vue3-simple-typeahead.css';

import Loading from '@/components/item/Loading.vue';
export default {
  components: { Loading, SimpleTypeahead },
  name: 'InventoryForm',
  props: {
    title: String,
    data: Object,
    location: String
  },
  data(){
    return{
        formTitle : this.title,
        formData : this.data,
        addStatus : this.title == 'Add Inventory',
        formId : this.title != 'Add Inventory' ? this.data.id : null,
        viewStatus : this.title == 'View Detail Inventory',
        dataResults : [],
        productWarning : false
    }
  },
  setup() {
    const success = ref(null);
    const loading = ref(false);
    const error = ref(null);
    const dataProducts = ref(null);
    const state = reactive({
            stock: '',
            total: '',
            productDto: null
         });
    const rules = computed(() => {
         return {
            stock: { required },
            total: { required },
            productDto: { required }
         }
    });
    const v$ = useValidate(rules, state)
    async function fetchData() {
      loading.value = true;
      const result = await HTTP.get(`products`).then(response => {
          dataProducts.value = response.data.data.content
        })
        .catch(e => {
           error.value = 'No Products Parameter found'
        })
      loading.value = false;
    }
    async function saveData() {
      loading.value = true;
      const requestData = {
        warehouse: this.location,
        stock: state.stock,
        total: state.total,
        productDto: state.productDto,
        inventoryType: "INVENTORY_IN"
      }
      if(this.formId){
        const result = await HTTP.put('inventory/'+this.formId, JSON.stringify( requestData )).then(response => {
                success.value = response.data.message
                loading.value = false;
                setTimeout(() => {
                    this.$emit('form-modal-done')
                },1000)
            })
            .catch(e => {
                loading.value = false;
                const jsonError = e.toJSON();
                error.value = jsonError.message
            })
      }else{
        const result = await HTTP.post(`inventory/`, JSON.stringify( requestData )).then(response => {
                success.value = response.data.message
                loading.value = false;
                setTimeout(() => {
                    this.$emit('form-modal-done')
                },1000)
            })
            .catch(e => {
                loading.value = false;
                const jsonError = e.toJSON();
                error.value = jsonError.message
            })
      }
      loading.value = false;
    }

    onMounted(() => {
      fetchData()
    });

    return {
      success,
      loading,
      error,
      state,
      v$,
      saveData,
      dataProducts
    };
  },methods: {
    calculateTotal(){
        this.state.total = null
        if(this.state.productDto != null && this.state.stock != 0){
            this.state.total = this.state.productDto.price * this.state.stock
        }
    },
    productProjectionFunction(product){
        const categoryDto = {
          MAKANAN : 'Makanan',
          OBAT_OBATAN : 'Obat', 
          MINUMAN : 'Minuman', 
          KOSMETIK : 'Kosmetik'
        }
        return product.name + ' - ' + categoryDto[product.categoryProduct]
    },
    selectProductEventHandler(product){
        this.state.productDto = product
        this.calculateTotal()
        this.productWarning = false
    },
    onInputProductEventHandler(){
        this.state.productDto = null
    },
    onBlurProductEventHandler(){
        this.productWarning = this.state.productDto == null ? true : false;
    },
    onSubmit(e) {
      this.v$.$validate()
      console.log(this.v$.$error)
      if(!this.v$.$error){
         this.saveData()
      }
      e.preventDefault()
    },
    onReset() {
        e.preventDefault()
    }
  },mounted(){
    if(!this.addStatus){
        this.state.warehouse = this.formData.warehouse
        this.state.stock = this.formData.stock
        this.state.total = this.formData.total
        this.state.productDto = this.formData.productDto
    }
  }
}
</script>
<template>
    <Loading v-if="loading"/>
    <b-form v-if="!loading" @submit="onSubmit" @reset="onReset">
        <div class="card">
            <div class="card-header d-flex justify-content-between">
                <div class="header-title">
                    <h4 class="card-title">
                        {{formTitle}}
                    </h4>
                </div>
                <a class="badge bg-warning mr-2" href="#" @click="$emit('close-modal')"><i class="ri-arrow-go-back-fill mr-0"></i></a>
            </div>
            <div class="row">
                <div class="col-md-12" v-if="error || success">
                    <div class="alert alert-danger" v-if="error">
                        <div class="iq-alert-text">
                        {{error}}
                        </div>
                    </div>                    
                    <div class="alert alert-success" v-if="success">
                        <div class="iq-alert-text">
                        {{success}}
                        </div>
                    </div>
                </div>
                <div class="col-md-12">                     
                    <div class="form-group">
                        <label>Product Name *</label>
                        <SimpleTypeahead
                            id="form-product"
                            placeholder="Select Product..."
                            :items="dataProducts"
                            :minInputLength="2"
                            :itemProjection="productProjectionFunction"
                            :defaultItem="state.productDto"
                            @selectItem="selectProductEventHandler"
                            @onInput="onInputProductEventHandler"
                            @onBlur="onBlurProductEventHandler"
                        >
                        </SimpleTypeahead> 
                        <div class="help-block with-error" v-if="productWarning" >
                            <div class="alert alert-warning">
                                <div class="iq-alert-text">
                                    Pease select / hit product to commit selection product.
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="col-md-6">
                    <div class="form-group">
                        <label>Stock *</label>
                        <input v-model="state.stock" type="number" class="form-control" placeholder="Enter Stock" data-errors="Please Enter Stock." :disabled = "viewStatus" @keyup="calculateTotal()" required>
                        <div class="help-block with-errors" v-if="v$.stock.$error" >
                            <div class="alert alert-danger">
                                <div class="iq-alert-text">
                                {{v$.stock.$errors[0].$message}}
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="col-md-6">
                    <div class="form-group">
                        <label>Total *</label>
                        <input v-model="state.total" type="number" class="form-control" placeholder="Enter Total" data-errors="Please Enter Total." disabled required>
                        <div class="help-block with-errors"  v-if="v$.total.$error" >
                            <div class="alert alert-danger">
                                <div class="iq-alert-text">{{v$.total.$errors[0].$message}}</div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="col-md-12">
                <button v-if="!viewStatus" type="submit" class="btn btn-primary btn-block">Save</button>
                <button v-if="!viewStatus && addStatus" type="reset" class="btn btn-danger btn-block">Reset</button>
            </div>
        </div>
    </b-form>
</template>
<style scoped>
    .col-md-12:nth-child(2) > .form-group:first-child{
        margin-top: 1rem;
    }
    .row{
        padding: 1rem;
    }
</style>
<style>
    #form-product{
        height: 45px;
        line-height: 45px;
        background: #ffffff;
        border: 1px solid #DCDFE8;
        font-size: 14px;
        color: #676E8A;
        -webkit-border-radius: 10px;
        -moz-border-radius: 10px;
        -ms-border-radius: 10px;
        -o-border-radius: 10px;
        border-radius: 10px;
        box-shadow: none;
        display: block;
        width: 100%;
        padding: 0.375rem 0.75rem;
        transition: border-color 0.15s ease-in-out, box-shadow 0.15s ease-in-out;
    }
    div.simple-typeahead-list{
        border-radius: 10px;
    }
    div.simple-typeahead-list-item:first-child{
        border-radius: 10px 10px 0px 0px;
    }
    div.simple-typeahead-list-item:last-child{
        border-radius: 0px 0px 10px 10px;
    }
</style>
